#! /perl -w
use strict;
use open IO => ':encoding(shift_jis)';
use Foundation;
# man PerlObjCBridge

# TeX 琔ȂǂāCԂ̌₷.

sub SetFileTypes($) {
	my ($path) = @_;
	my $sign = NSNumber->numberWithInt_(unpack("N", 'jtxE'));
	my $type = NSNumber->numberWithInt_(unpack("N", 'utf8'));
	my $dict = NSMutableDictionary->dictionary;
	$dict->setObject_forKey_($sign, "NSFileHFSCreatorCode");
	$dict->setObject_forKey_($type, "NSFileHFSTypeCode");
	NSFileManager->defaultManager
		->changeFileAttributes_atPath_($dict, $path);
}

sub Get($) {
	my ($txt) = @_;
	my $got = ($txt =~ /=/) ? 'it is an equality' : 'a word';
	if ($txt =~ /(\.|,)(\\tag\{.*?\}| |\t|\n)*$/) {
		$got .= $1;
	}
	return $got;
}
sub EatBraket($) {
	my ($txt) = @_;
	my $count = 0;
	do {
		$txt =~ s/^(.*?)\}//s or last;
		my $str = $1;
		$count += ($str =~ tr/{//);
	} while (--$count > 0);
	return $txt;
}
sub UnDef($) {
	my ($txt) = @_;
	my $res = '';
	while ($txt =~ s/\\(def\\|(re)?newcommand(\\|\{.*?\})|(re)?new(environment|theorem)\{.*?\})//) {
		$res .= $`;
		$txt = $';
		$txt = EatBraket $txt if ($1 =~ /^(re)?new(environment|theorem)/);
		$txt = EatBraket $txt;
	}
	return $res.$txt;
}

sub Xfer() {
	my $text = "";
	my @lines = split(/\n|\r/, join('', <IN>));
	while (defined(my $line = shift(@lines))) {
		$line =~ s/\\[^a-zA-Z]/ /g;
		$line =~ s/%.*//g;
		if ($line =~ /\\begin(\{document\}|document[^a-zA-Z])/) {
			$text = '';
		} elsif ($line =~ /\\end(\{document\}|document[^a-zA-Z])/) {
			last;
		} else {
			$text .= "$line\n";
		}
	}
	$text = UnDef($text);
	$text =~ s/\\begin(\{(eq|gather|align).*?\})(.*?)\\end\1/Get($3)/sge;
	$text =~ s/\\([A-Za-z]+|[^A-Za-z])/ /sg;
	$text =~ s/\$\$(.*?)\$\$/Get($1)/sge;
#	$text =~ s/\[(.*?)\]/Get($1)/sge;
	$text =~ s/\$(.*?)\$/Get($1)/sge;
#	$text =~ s/\((.*?)\)/Get($1)/sge;
	$text =~ s/[ \t^_#\{\}]+/ /sg;
	$text =~ s/ +\n/\n/sg;
	$text =~ s/\n{2,}/\n/sg;
	return $text;
}

sub DoFile($) {
	my ($src) = @_;
	print "$src\n";
	open IN, $src or die "Can't read $src";
	my $text = Xfer;
	close IN;
	my $trg = "$src.TEXT";
	open OUT, ">$trg" or die "Can't write $trg";
	print OUT $text;
	close OUT;
	undef $text;
	SetFileTypes($trg);
}

sub DoObj($);
sub DoObj($) {
	my ($obj) = @_;
	if (-d $obj) {
		opendir DIR, $obj
		or die "Can't scan $obj";
		my @items = readdir DIR;
		closedir DIR;
		for (@items) { DoObj("$obj/$_") unless /^\./; }
	} else {
		DoFile $obj;
	}
}

print "\n**** TeXtoTEXT ****\n";

while (my $item = shift) { DoObj $item; }

print "\n**** end ****\n";

