#!/usr/bin/perl -w
use strict;
use utf8;

# 正規表現による文書内容検索

# 使用法:
#	17 行目の pattern を修正して，このウィンドウにフォルダを落とすと，
#		pattern に一致する行を ***.fnd に記録する．
#	19 行目の '' を ".found" にすれば結果は ファイル名.found に出力される．

use Encode;
use Foundation;
# man PerlObjCBridge

sub Match($) {
	return $_[0] =~ /小磯/; # pattern
}
my $Out = ''; #".found";

sub CheckFileName($) {
	return 1;
	return $_[0] =~ /\.text$/ or $_[0] !~ /\./;
}

my %Ignore;
{
	my @ignores = ("Icon\r", "Icon\n");
	for (@ignores) { $Ignore{$_} = 1; };
}
my @Encodings = ('utf8', 'shiftjis', 'euc-jp', 'iso-Latin-1');
	# +? 'iso-2022-jp' is 7-bit encoding. difficult to detect
my $Debug = '';

sub DoFile($) {
	my ($file) = @_;
	return "" if (-l $file or not CheckFileName($file));
	warn "open $file\n" if $Debug;
	unless (open(IN, "<:bytes", $file)) {
		warn "can't open file '$file': $!\n";
		return;
	}
	my $data = join('', <IN>);
	close(IN);
	my $text = "";
	if (length($data)) {
		for (@Encodings) {
			undef $@;
			$text = eval { Encode::decode($_, $data, Encode::FB_CROAK); };
			last unless ($@);
		}
		unless ($text) {
			warn "bad encoding: '$file'\n";
			return;
		}
	}
	$text =~ s/\r/\n/g;
	my @lines = split("\n", $text);
	my $found = '';
	for (my $idx = 0; $idx < @lines; ++$idx) {
		my $line = $lines[$idx];
		next unless (Match($line));
		unless ($found) {
			$found = 1;
			print "\n" unless $Out;
			print "$file\n";
			print OUT "\n**** $file\n" if $Out;
		}
		if ($Out) { print OUT "$idx:  $line\n"; }
		else { print "$idx:  $line\n"; }
	}
}

sub Scan($);
sub Scan($) {
	my ($obj) = @_;
	return if (-l $obj);
	if (-d $obj) {
		unless (opendir(DIR, $obj)) {
			warn "can't scan '$obj': $!\n";
			return;
		}
		my @items = readdir(DIR);
		closedir(DIR);
		for my $item (@items) {
			utf8::decode($item);
			next if ($item =~ /^\./);
			Scan("$obj/$item") unless $Ignore{$item};
		}
	} else {
		DoFile($obj);
	}
}

sub SetFileTypes($) {
	my ($path) = @_;
	my $sign = NSNumber->numberWithInt_(unpack("N", 'jtxE'));
	my $type = NSNumber->numberWithInt_(unpack("N", 'utf8'));
	my $dict = NSMutableDictionary->dictionary;
	$dict->setObject_forKey_($sign, "NSFileHFSCreatorCode");
	$dict->setObject_forKey_($type, "NSFileHFSTypeCode");
	NSFileManager->defaultManager
		->changeFileAttributes_atPath_($dict, $path);
}

while (my $dir = shift) {
	utf8::decode($dir);
	print "\n**** Find in $dir\n";
	if ($Out) {
		unless (open(OUT, ">$dir$Out")) {
			warn "Can't open dir '$dir$Out': $!\n";
			next;
		}
		Scan $dir;
		print "**** Result: '$dir$Out'\n";
		close(OUT);
		SetFileTypes("$dir$Out");
	} else {
		Scan $dir;
	}
}

print "**** end of find ****\n";

