#!/usr/bin/perl -w
use strict;
use utf8;

my $LineWidth	= 16;
my $SeparateWidth	= 4;

my $Path = shift or die;
open(IN, "<:bytes", $Path);
my $Data = join('', <IN>);
close(IN);

sub Print($) {
	my ($buff) = @_;
	return unless ($buff);
	my $width = $LineWidth * 2 + $SeparateWidth;
	my $hex = unpack("H*", $buff);
	print $hex, ' ' x ($width - length($hex));
	print "/* ";
	for (my $i = 0; $i < length($buff); ++$i) {
		my $chr = substr($buff, $i, 1);
		print ((' ' le $chr and $chr lt "\x7f") ? $chr : ".");
	}
	print " */\n";
}

for (my $idx = 0; $idx < length($Data); $idx += $LineWidth) {
	Print substr($Data, $idx, $LineWidth);
}
