#! /usr/bin/perl -w
use strict;
use utf8;

# ps, eps を pdf に変換する．
# 変換したいファイルをマウスでこのウィンドウに落とすこと．
# 標準で切り詰めた pdf を生成する．

# 切り詰めた pdf を生成
my $Options = "-sDEVICE=pdfwrite -dBATCH -dNOPAUSE -dEPSCrop";
# 切り詰めない pdf を生成
#my $Options = "-sDEVICE=pdfwrite -dBATCH -dNOPAUSE";

die unless @ARGV;

sub GS_Path();
my $gs = GS_Path();

for (my $path = shift) {
	my ($dir, $name) = $path =~ m|^(.*)/([^/]*)(\.[^./]*)?$|;
	chdir $dir;
	`$gs $Options -sOutputFile='$name.pdf' '$path'`;
}

sub GS_Path() {
	my $path = $ENV{'JTeXEditTeXBinPath'};
	return "$path/gs" if ($path and -x "$path/gs");
	$path = `which gs`;
	for my $p (split("\n", $path)) {
		return $p if ($p and -x $p);
	}
	$path = "/usr/local/bin/gs";
	return $path if (-x $path);
	die "gs not found.";
}
